<html devsite><head>
    <title>实施“提供紧急呼叫”功能</title>
    <meta name="project_path" value="/_project.yaml"/>
    <meta name="book_path" value="/_book.yaml"/>
  </head>
  <body>
  <!--
      Copyright 2017 The Android Open Source Project

      Licensed under the Apache License, Version 2.0 (the "License");
      you may not use this file except in compliance with the License.
      You may obtain a copy of the License at

          http://www.apache.org/licenses/LICENSE-2.0

      Unless required by applicable law or agreed to in writing, software
      distributed under the License is distributed on an "AS IS" BASIS,
      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
      See the License for the specific language governing permissions and
      limitations under the License.
  -->

<p>从 2017 年 1 月 1 日开始，在印度地区销售的所有移动设备都必须应印度电信部门 (DoT) 的要求提供紧急呼叫按钮。为响应这些监管要求，Android 包含了“提供紧急呼叫”功能的参考实现，以启用 Android 设备上的紧急呼叫按钮。</p>

<p>此功能在 Android 8.0 和更高版本中默认启用，但较早版本中必须安装相应的补丁程序。目前，该功能专门针对在印度市场销售的设备；不过，鉴于该功能在印度境外无效，因此也可以在全球范围销售的所有设备上提供。</p>

<h2 id="examples-source">示例和源代码</h2>
<p>“提供紧急呼叫”功能在 Android 开放源代码项目 (AOSP) 的 <a href="https://android.googlesource.com/platform/frameworks/base/">frameworks/base</a> 项目中实现。它在 master 分支中提供，并将在未来的 Android 版本中默认启用。</p>

<p>目前，以下分支和提交中已提供该功能。提供这些信息是为了方便设备制造商轻松将必要的更改以补丁程序的形式添加到现有版本中。想要实现 AOSP 参考“提供紧急呼叫”功能的设备制造商可以从适用的分支中挑选提交并加入到自己的版本中。</p>

<p class="table-caption" id="cherry-picks-reference-implementation">
<strong>表 1.</strong> 挑选 AOSP 参考“提供紧急呼叫”功能</p>
<table>
<tbody>
<tr>
<th scope="col">分支</th>
<th scope="col">提交</th>
</tr>
<tr>
<td>master</td>
<td><a href="https://android-review.googlesource.com/#/c/284723/">e0c3c66</a> 添加了“提供紧急呼叫”功能<br />
<a href="https://android-review.googlesource.com/#/c/287188/">42a4338</a> 添加了紧急操作字符串的翻译<br />
<a href="https://android-review.googlesource.com/#/c/286858/">4df8d64</a> 修复了“提供紧急呼叫”在平板电脑上显示的问题</td>
</tr>
<tr>
<td>nougat-dev</td>
<td><a href="https://android-review.googlesource.com/#/c/284761/">e6680d9</a> 添加了“提供紧急呼叫”功能<br />
<a href="https://android-review.googlesource.com/#/c/287293/">95e1865</a> 添加了紧急操作字符串的翻译<br />
<a href="https://android-review.googlesource.com/#/c/286953/">a70bb89</a> 修复了“提供紧急呼叫”在平板电脑上显示的问题</td>
</tr>
<tr>
<td>marshmallow-dev</td>
<td><a href="https://android-review.googlesource.com/#/c/284624/">cd22634</a> 添加了“提供紧急呼叫”功能<br />
<a href="https://android-review.googlesource.com/#/c/286937/">13f51c6</a> 添加了紧急操作字符串的翻译<br />
<a href="https://android-review.googlesource.com/#/c/287241/">6531666</a> 修复了“提供紧急呼叫”在平板电脑上显示的问题</td>
</tr>
<tr>
<td>lollipop-mr1-dev</td>
<td><a href="https://android-review.googlesource.com/#/c/284743/">5fbc86b</a> 添加了“提供紧急呼叫”功能<br />
<a href="https://android-review.googlesource.com/#/c/287382/">1b60879</a> 添加了紧急操作字符串的翻译<br />
<a href="https://android-review.googlesource.com/#/c/286856/">d74366f</a> 修复了“提供紧急呼叫”在平板电脑上显示的问题</td>

</tr>
</tbody>
</table>

<h2 id="implementation">实现</h2>
<p>“提供紧急呼叫”功能不会更改通过 Android SDK 公开的 API。该功能启用并激活后，会提供两个可启动 112 紧急呼救（印度的唯一紧急呼救号码，由印度电信部门强制实施）的触发器。</p>
<p>紧急呼救有两种启动方式：</p>

<div style="width:80%">
<table>
<tbody><tr>
<th width="50%">长按锁定屏幕上的<strong>紧急呼救</strong><br />按钮</th>
<th width="50%">点按全局操作菜单中的<strong>紧急呼救</strong><br />选项</th>
</tr>
<tr>
<td style="text-align: center">
<img src="/devices/tech/connect/images/emergency-button.png" alt="紧急呼叫按钮"/>
<figcaption><strong>图 1</strong> 锁定屏幕上的<strong>紧急呼救</strong>按钮。</figcaption></td>
<td style="text-align: center">
<img src="/devices/tech/connect/images/emergency-option.png" alt="紧急呼叫选项"/>
<figcaption><strong>图 2.</strong> 全局操作菜单上的<strong>紧急呼救</strong>动作（长按电源键可访问）。
</figcaption></td>
</tr>
</tbody></table>
</div>

<p>该功能引入了以下内部组件：</p>
<ul>
<li>EmergencyAffordanceManager
<pre class="devsite-click-to-copy">
frameworks/base/core/java/com/android/internal/policy/EmergencyAffordanceManager.java
</pre>
</li>
<li>EmergencyAffordanceService
<pre class="devsite-click-to-copy">
frameworks/base/services/core/java/com/android/server/emergency/EmergencyAffordanceService.java
</pre>
</li>
</ul>

<h3 id="EmergencyAffordanceManager">EmergencyAffordanceManager</h3>
<p>EmergencyAffordanceManager 提供使用“提供紧急呼叫”功能的内部 API。它提供启动紧急呼救的方法，并在运行时查询是否应启用该功能。</p>
<ul>
<li><code>void performEmergencyCall()</code>。启动紧急呼救。</li>
<li><code>boolean needsEmergencyAffordance()</code>。确定是否应启用该功能。</li>
</ul>

<p>该功能可在构建时永久禁用，具体方法是将 <code>EmergencyAffordanceManager.ENABLED</code> 常量改为 <code>false</code>。这会导致 <code>needsEmergencyAffordance()</code> 始终返回 false 并阻止 <code>EmergencyAffordanceService</code> 启动。</p>

<h3 id="EmergencyAffordanceService">EmergencyAffordanceService</h3>
<p><code>EmergencyAffordanceService</code> 是一种系统服务，用于监控所有检测到的移动网络的移动设备国家/地区代码 (MCC) 和安装的 SIM 卡的 MCC。如果任何安装的 SIM 卡或检测到的移动网络的 MCC 与印度的其中一个 MCC（404、405）相匹配，则该功能将会启用。这意味着，即使没有 SIM 卡，该功能也可以在印度启用。前提是，假设在没有安装 SIM 卡的情况下，移动网络允许注册紧急呼救。该功能将保持启用状态，直到安装了非印度 SIM 卡且没有检测到具有匹配 MCC 的网络。</p>

<p>以下资源和设置会影响“提供紧急呼叫”功能的行为。如果配置类型是：</p>
<ul>
<li><strong>资源</strong>，则是在 <code>frameworks/base/core/res/res/values/config.xml</code> 中定义的内部资源。</li>
<li><strong>设置</strong>，则是在系统设置提供程序中存储的设置。</li>
</ul>

<p class="table-caption" id="settings-affecting behavior">
<strong>表 2. </strong> 影响“提供紧急呼叫”功能行为的设置</p>
<table>
<tbody>
<tr>
<th scope="col">配置类型</th>
<th scope="col">名称</th>
<th scope="col">说明</th>
</tr>
<tr>
<td>资源</td>
<td>config_emergency_call_number</td>
<td>在紧急呼救启动时自动拨打的电话号码。<br />类型：字符串<br />默认值：112</td>
</tr>
<tr>
<td>资源</td>
<td>config_emergency_mcc_codes</td>
<td>列出应该激活该功能的 MCC 的整数数组。<br />类型：整数数组<br />默认值：{404,405}</td>
</tr>
<tr>
<td>设置</td>
<td>emergency_affordance_number</td>
<td>使用“提供紧急呼叫”致电号码的全局设置覆盖。此配置仅影响可调试的构建映像（即构建类型为 userdebug 或 eng）。此配置仅用于测试目的。<br />类型：字符串<br />默认值：未设置</td>
</tr>
<tr>
<td>设置</td>
<td>force_emergency_affordance</td>
<td>全局设置，是否显示“提供紧急呼叫”（无论设备状态如何）。此配置仅用于测试目的。<br />类型：布尔值（1 或 0）<br />默认值：未设置 --&gt; 0</td>
</tr>
</tbody>
</table>

<h3 id="112">启用 112 紧急呼救</h3>
<p>“提供紧急呼叫”功能使用紧急拨号器连接通话，因此通话可以在锁屏状态下连接。紧急拨号器只能将通话连接到无线界面层 (RIL) 提供的号码列表：</p>

<ul>
<li>在未安装 SIM 卡时，通过系统属性 <code>ril.ecclist</code> 连接；</li>
<li>在插入 SIM 卡且 <code><var>SimSlotNumber</var></code>
是默认订阅者的槽位 ID 时，通过系统属性 <code>ril.ecclist<var>SimSlotNumber</var></code> 连接。</li>
</ul>

<p>使用“提供紧急呼叫”功能的设备制造商必须确保在印度地区销售的设备始终将 112 作为 RIL 中的紧急呼救号码。</p>

<h2 id="validation">验证</h2>
<p>在可调式的构建上测试时，可以使用以下命令更改呼叫的号码：</p>
<pre class="devsite-terminal devsite-click-to-copy">
adb shell settings put global emergency_affordance_number <var>NUMBER_TO_CALL</var>
</pre>

<p>虽然此设置可以在普通用户构建中设置，但会被忽略。要实际连接通话，号码必须存在于 RIL 提供的紧急呼救号码列表中。这可以临时设置，具体方法是在 userdebug 设备上使用通过根 shell 执行的以下命令：</p>
<pre class="devsite-terminal devsite-click-to-copy">
setprop ril.ecclist "$(getprop ril.ecclist),<var>NUMBER_TO_CALL</var>"
</pre>

<p>此外，如需在未检测到印度移动网络或未插入印度 SIM 卡的情况下强制启用“提供紧急呼叫”功能，可以使用以下命令：</p>
<pre class="devsite-terminal devsite-click-to-copy">
adb shell settings put global force_emergency_affordance 1
</pre>

<p>建议至少对以下情况进行测试：</p>

<ul>
<li>激活之后，长按锁定屏幕上的<strong>紧急呼救</strong>按钮（图 1）可呼叫指定紧急呼救号码。
</li>
<li>激活之后，全局操作菜单中会显示<strong>紧急呼救</strong>选项，点按该选项可呼叫指定紧急呼救号码。</li>
<li>在未检测到印度移动网络且安装了非印度 SIM 卡的情况下，该功能<strong>不会</strong>激活。</li>
<li>在安装印度 SIM 卡的情况下，无论是否检测到移动网络，该功能都<strong>会激活</strong>。</li>
<li>在检测到印度移动网络的情况下，无论是否安装了 SIM 卡，该功能都<strong>会激活</strong>。</li>
</ul>

<p>如果设备支持多个 SIM 卡，则测试应确保 SIM 卡 MCC 检测功能在每个 SIM 卡插槽中都能正常运行。“提供紧急呼叫”功能不受 Android 兼容性影响，因此不用进行 CTS 测试。</p>

<h2 id="faq">常见问题解答</h2>

<h5 id="q-112">问：紧急呼救号码 112 尚未在印度授权使用，仍然使用该号码吗？</h5>
<p>根据集成紧急通信与应答系统 (IECRS) 的定义，112 是即将在印度用于公共安全应答点 (PSAP) 的号码。在 PSAP 获得授权之前，所有对 112 的呼叫都将转接到现有的 100 紧急呼救号码（尽管是运营商的责任而非 Android 的责任）。</p>

<h5 id="q-other-triggers">问：使用其他触发操作怎么样？比如按电源按钮三次？</h5>
<p>设备制造商可以选择实施其他触发操作。然而，虽然点按硬件电源按钮三次也是印度电信部门批准的触发操作，但这种触发操作在 AOSP 参考实现中<strong>不受支持</strong>，因为有部分其他广泛使用的应用（如相机应用）使用电源按钮手势，包括重复点按电源按钮。这些应用可能会干扰紧急拨号器，或者用户在尝试触发这些应用中的操作时可能会意外触发紧急呼叫按钮。</p>

</body></html>